#!/usr/bin/python
# -*- coding: utf-8 -*-
import es
#import random
import playerlib
#import usermsg
import popuplib
import weaponlib
superhero = es.import_addon('superhero')

def load():
    global bat_menu
    bat_menu = popuplib.easymenu('bat_menu', 'choice', bat_menu_selection)
    bat_menu.settitle('Pick a Weapon Category:') 
    bat_menu.addoption('pistols','Pistols')
    bat_menu.addoption('smg','SMG')
    bat_menu.addoption('rifles','Rifles')
    
    global bat_menu_pistols
    bat_menu_pistols = popuplib.easymenu('bat_menu_pistols', 'choice', weapon_give)
    bat_menu_pistols.settitle('Pick a Weapon:') 
    bat_menu_pistols.addoption('deagle','Deagle')
    bat_menu_pistols.addoption('usp','Usp')
    bat_menu_pistols.addoption('glock','Glock')
    
    global bat_menu_smg
    bat_menu_smg = popuplib.easymenu('bat_menu_smg', 'choice', weapon_give)
    bat_menu_smg.settitle('Pick a Weapon Category:') 
    bat_menu_smg.addoption('tmp','Tmp')
    bat_menu_smg.addoption('mp5navy','MP5')
    bat_menu_smg.addoption('p90','P90')
    
    global bat_menu_rifles
    bat_menu_rifles = popuplib.easymenu('bat_menu_rifles', 'choice', weapon_give)
    bat_menu_rifles.settitle('Pick a Weapon Category:') 
    bat_menu_rifles.addoption('ak47','Ak47')
    bat_menu_rifles.addoption('m4a1','M4A1')
    bat_menu_rifles.addoption('sg552','Krieg')
    
    if not es.exists('saycommand', 'batmenu'):
        es.regsaycmd('batmenu', 'superhero/heroes/Batman/batmenu')   
    print "[SH] Batman successfully loaded"  
    
def unload():
    es.unregsaycmd('batmenu')
    bat_menu.delete()
    bat_menu_pistols.delete()
    bat_menu_smg.delete()
    bat_menu_rifles.delete()

def batmenu():
    userid = es.getcmduserid()
    userid = str(userid)
    if superhero.hasHero(userid,'Batman'):
        if es.exists('userid', userid):
            myPlayer = playerlib.getPlayer(userid)
            if int(myPlayer.isdead) != 1:
                popuplib.send('bat_menu',userid)
    
def bat_menu_selection(userid,choice,popupname):
    userid = str(userid)
    if es.exists('userid', userid):
        choice = str(choice)
        menuname = 'bat_menu_'+choice
        popuplib.send(menuname,userid)
    
def bat_menu_pistols(userid,choice,popupname):
    userid = str(userid)
    if es.exists('userid', userid):
        choice = str(choice)
        weapon_give
    
def bat_menu_smg(userid,choice,popupname):
    userid = str(userid)
    if es.exists('userid', userid):
        userid = str(userid)
        choice = str(choice)
    
    
def bat_menu_rifles(userid,choice,popupname):
    userid = str(userid)
    if es.exists('userid', userid):
        choice = str(choice)  
    
def weapon_give(userid,weapon,popupname):
    userid = str(userid)
    if es.exists('userid', userid):
        weapon = str(weapon)
        if not 'bat_weapons' in superhero.Users[userid]:
            superhero.Users[userid]['bat_weapons'] = 'tmp,mp5navy,p90,ak47,m4a1,sg552,deagle,usp,glock'
        bat_weapons = superhero.Users[userid]['bat_weapons']
        bat_weapons = bat_weapons.split(',')
        if weapon in bat_weapons:
            weapon_give = 'weapon_'+weapon
            player = playerlib.getPlayer(userid)
            primary = player.getPrimary()
            secondary = player.getSecondary()
            prim_weapons = ['tmp','mp5navy','p90','ak47','m4a1','sg552']
            sec_weapons = ['deagle','usp','glock']
            if weapon in prim_weapons:
                if str(primary) != '0':
                    handle = es.getplayerhandle(userid)
                    usp = weaponlib.getWeapon(primary)
                    # Loop through all usps to find the one belonging to the player
                    for index in usp.indexlist:
                        if es.getindexprop(index, 'CBaseEntity.m_hOwnerEntity') == handle:
                            # Remove the player's primary
                            es.server.cmd('es_xremove %s' % index)                 
            if weapon in sec_weapons:
                if str(secondary) != '0':
                    handle = es.getplayerhandle(userid)
                    usp = weaponlib.getWeapon(secondary)
                    # Loop through all usps to find the one belonging to the player
                    for index in usp.indexlist:
                        if es.getindexprop(index, 'CBaseEntity.m_hOwnerEntity') == handle:
                            # Remove the player's secondary
                            es.server.cmd('es_xremove %s' % index)     
            es.give(userid,weapon_give)
            bat_weapons.remove(weapon)
            string = bat_weapons[0]
            for key in bat_weapons:
                if not key in string:
                    string = string+','+str(key)
            superhero.Users[userid]['bat_weapons'] = string
        else:
            es.tell(userid,'#multi','#green[SH] #lightgreenWeapon has already been picked once this round')
    
def player_spawn(ev):
    userid = str(ev['userid'])
    if es.exists('userid',userid):
        if superhero.hasHero(userid,'Batman'):       
            myPlayer = playerlib.getPlayer(userid)
            if int(myPlayer.isdead) != 1:
                es.tell(userid,'#multi','#green[SH]#lightgreen Batman activated. Type #greenbatmenu #lightgreento pick Weapons')
                superhero.Users[userid]['bat_weapons'] = 'tmp,mp5navy,p90,ak47,m4a1,sg552,deagle,usp,glock'
                if popuplib.isqueued('bat_menu',userid):
                    return
                popuplib.send('bat_menu',userid)