﻿#!/usr/bin/python
# -*- coding: utf-8 -*-    
import es
import random
import playerlib
import gamethread
superhero = es.import_addon('superhero')

def load():
    print "[SH] Poison Ivy successfully loaded"

def player_spawn(ev):
    userid = str(ev['userid'])
    if superhero.hasHero(ev['userid'],'Poison Ivy'):
        player = playerlib.getPlayer(userid)
        wcs_dead = player.isdead
        if wcs_dead != 1:
            superhero.Users[userid]['Poison'] = 0

def player_hurt(ev):
    steamid = es.getplayersteamid
    if steamid == 'BOT': steamid = es.getplayername
    userid = str(ev['userid'])
    attacker = str(ev['attacker'])
    if superhero.hasHero(attacker,'Poison Ivy'):
        dice = random.randint(1,5)
        if dice == 1 or ev['weapon'] == 'knife':
            if 'Poison' in superhero.Users[attacker]:
                if superhero.Users[attacker]['Poison'] == 0:
                    superhero.Users[attacker]['Poison'] = 1
                    venom = random.randint(20, 40)
                    es.tell(attacker, '#multi', '#green[SH]#lightgreen You have poisoned #green%s #lightgreenfor #green%i #lightgreenhealth'%(ev['es_username'], venom))
                    es.tell(userid, '#multi', '#green[SH]#lightgreen #green%s #lightgreenhas poisoned you for #green%i #lightgreenhealth'%(ev['es_attackername'], venom))
                    VenomCycle(userid, venom, attacker)
            
def VenomCycle(userid, venom, attacker):
    player = playerlib.getPlayer(userid)
    if venom == 0:
        superhero.Users[attacker]['Poison'] = 0
        return
    elif venom == 1 and not bool(player.isdead):
        es.server.queuecmd('damage %s 1 1024 %s'%(userid,attacker))
        venom = venom - 1
        fade(userid, 0, 0.2, 0.2, 0, 255, 0, 50)
        if not bool(player.isdead):
            gamethread.delayed(1, VenomCycle, (userid, venom, attacker))
    elif venom == 2 and not bool(player.isdead):
        es.server.queuecmd('damage %s 2 1024 %s'%(userid,attacker))
        venom = venom - 2
        fade(userid, 0, 0.2, 0.2, 0, 255, 0, 50)
        if not bool(player.isdead):
            gamethread.delayed(1, VenomCycle, (userid, venom, attacker))
    elif venom == 3 and not bool(player.isdead):
        es.server.queuecmd('damage %s 3 1024 %s'%(userid,attacker))
        venom = venom - 3
        fade(userid, 0, 0.2, 0.2, 0, 255, 0, 50)
        if not bool(player.isdead):
            gamethread.delayed(1, VenomCycle, (userid, venom, attacker))
    elif venom > 0 and not bool(player.isdead):
        es.server.queuecmd('damage %s 4 1024 %s'%(userid,attacker))
        venom = venom - 4
        fade(userid, 0, 0.2, 0.2, 0, 255, 0, 50)
        if not bool(player.isdead):
            gamethread.delayed(1, VenomCycle, (userid, venom, attacker))
        
def fade(users, type, fadetime, totaltime, r, g, b, a):
    t = int(type)
    if t == 1:
        type = 2
    elif t == 0:
        type = 1
    else:
        type = 8 + 16
    es.usermsg("create", "fade", "Fade")
    es.usermsg("write", "short", "fade", float(fadetime) * 1000)
    es.usermsg("write", "short", "fade", float(totaltime) * 1000)
    es.usermsg("write", "short", "fade", int(type))
    es.usermsg("write", "byte", "fade", int(r))
    es.usermsg("write", "byte", "fade", int(g))
    es.usermsg("write", "byte", "fade", int(b))
    es.usermsg("write", "byte", "fade", int(a))
    es.usermsg("send", "fade", users)
    es.usermsg("delete", "fade")