#!/usr/bin/python
# -*- coding: utf-8 -*-
##########################################
# Superhero Mod                          #
# By: NeoSan                             #
#                                        #
# Original Script by Icetouch & Mordavolt#
#                                        #
# Visit http://forums.eventscripts.com   #
# for the latest mod                     #
#                                        #
# Date created: 11.27.2012               #
# First release: 03.07.2012              #
# Latest Version: 0.3.4.1                #
##########################################
import spe_effects
from playerlib import getPlayer
from random import randint
import os
import keyvalues
import playerlib
import cfglib
import langlib
import random
import usermsg
import es, sys, os.path, time
import traceback as tb_module
import popuplib
info = es.AddonInfo()
info['name'] = "Superhero" 
info['version'] = "0.3.4.1"
info['author'] = "NeoSan" 
info['url'] = "http://forums.eventscripts.com"
info['basename'] = "superhero"
info['description'] = "Superhero Source Mod"
es.set('sh_version',info['version'])
Users = keyvalues.getKeyGroup("Users")
Users = {}
config = cfglib.AddonCFG(es.getAddonPath("superhero") + "/superhero.cfg")
config.text("******************************")
config.text("       Superhero Config")
config.text("******************************")
herolist         = config.cvar("herolist","Agent Zero,Batman,Blade,Chucky,Daredevil,Dazzler,Dracula,Flash,General,Goku,HobGoblin,Invisible Man,Iron Man,Jubilee,Morph,Mystique,Nightcrawler,Poison Ivy,Predator,Punisher,Robin,Superman,Windwalker,Wolverine,Zeus",  "Heroes to load. Case Sensitive.")
xp_kill_min      = config.cvar("xp_kill_min",  10, "XP a Player receives each Kill min")
xp_kill_max      = config.cvar("xp_kill_max",  35, "XP a Player receives each Kill max")
xp_next_level    = config.cvar("xp_next_level", 100, "XP need to get a Level up")
xp_multi         = config.cvar("xp_multi",  1.1, "Increases the required XP again")
max_level        = config.cvar("max_level",   15, "What is the Max Level players can reach?")
buyxp            = config.cvar("buyxp",  1, "Buyxp command enabled? (0->off)")
xp_dollar        = config.cvar("xp_dollar",  0.015, "How many XP each $1?")
buyxp_players    = config.cvar("buyxp_players",  2, "How many Players are required for buyxp to be enabled?")
hero_pick        = config.cvar("hero_pick",  0, "Should a Message be displayed Ingame that you can /pick Heroes?")
start_level      = config.cvar("start_level",  1, "Do players get a New Player Bonus?")
drop_alive       = config.cvar("drop_alive", 0, "Should Players be able to drop Heroes while alive?")
popup_language   = config.cvar("popup_language",  "en", "popup language A N D for all other messages")
config.write() # Writes the .cfg to file

def load():
    print "[SH] Loading..."
    ## Load the ExtendedEvents Addon
    print "***** Loading ExtendedEvents manually... ******"
    es.load("extendedevents")
    es.server.cmd('extendedevents_load player_move') ## Used for advanced Invisible Man
    es.server.cmd('extendedevents_load player_drop') ## Used for Wolverine
    es.server.cmd('extendedevents_load player_duck') ## Used for...an upcoming Hero
    es.server.cmd('extendedevents_load player_flag') ## Used for map_end saving! DO NOT UNLOAD!
    # Loading restrictions
    # Only if not loaded by any other addon first
    # Currently not working on Linux, so taken out!
    #es.server.queuecmd('es_xload ezrestrict')  
    # creating tables
    # id,created,level,xp,connected,lastplayed,heroes
    es.sql('open','userdata', '|superhero/Userdata')
    es.sql('query','userdata', "CREATE TABLE IF NOT EXISTS users (id TEXT NOT NULL,created NUMERIC DEFAULT 0,level NUMERIC DEFAULT 0,xp NUMERIC DEFAULT 0,unspent NUMERIC DEFAULT 0,connected NUMERIC DEFAULT 0,lastplayed NUMERIC DEFAULT 0, heroes TEXT default 0,power1 TEXT default 0,power2 TEXT default 0,power3 TEXT default 0,PRIMARY KEY (`id`))")    
    config.execute() # Executes the .cfg to register changes   
    # setting variables
    global popup_language
    popup_language = es.ServerVar('popup_language')
    global rounds_played
    rounds_played = 0
    # Load Heroes
    es.server.queuecmd('es_xload superhero/heroes')
    # Load Admins
    es.server.queuecmd('es_xload superhero/admins')   
    # Create a group
    global heroes
    heroes = []
    ### Get the Strings the popup
    cmdlist_popup = langlib.Strings(es.getAddonPath("superhero") + "/languages/cmdlist_popup.ini")
    # Create popups
    global commandlist
    commandlist = popuplib.easymenu('commandlist','choice',commandlist_selection)
    commandlist.settitle('All Commands')   
    commandlist.addoption('help',cmdlist_popup('cmd_help',lang=str(popup_language))) # Done
    commandlist.addoption('herolist',cmdlist_popup('cmd_herolist',lang=str(popup_language))) # Done
    commandlist.addoption('playerinfo',cmdlist_popup('cmd_playerinfo',lang=str(popup_language)))
    commandlist.addoption('myheroes',cmdlist_popup('cmd_myheroes',lang=str(popup_language))) # Done
    commandlist.addoption('clearpowers',cmdlist_popup('cmd_clearpowers',lang=str(popup_language))) # Done
    commandlist.addoption('showmenu',cmdlist_popup('cmd_showmenu',lang=str(popup_language))) # Done
    commandlist.addoption('showxp',cmdlist_popup('cmd_showxp',lang=str(popup_language))) # Done
    commandlist.addoption('savexp',cmdlist_popup('cmd_savexp',lang=str(popup_language)))
    commandlist.addoption(None,cmdlist_popup('cmd_drop',lang=str(popup_language))) # Done
    commandlist.addoption(None,cmdlist_popup('cmd_buyxp',lang=str(popup_language)))
    commandlist.addoption(None,cmdlist_popup('cmd_binding',lang=str(popup_language)))
    helpbox_popup = langlib.Strings(es.getAddonPath("superhero") + "/languages/helpbox_popup.ini")
    global helpbox
    helpbox = popuplib.create('helpbox')
    helpbox.addline(helpbox_popup('helpbox_1',lang=str(popup_language)))
    helpbox.addline(helpbox_popup('helpbox_2',lang=str(popup_language)))
    helpbox.addline('\n\n')
    helpbox.addline(helpbox_popup('helpbox_3',lang=str(popup_language)))
    helpbox.addline(helpbox_popup('helpbox_4',lang=str(popup_language)))
    helpbox.addline(helpbox_popup('helpbox_5',lang=str(popup_language)))
    helpbox.addline(helpbox_popup('helpbox_6',lang=str(popup_language)))
    # Saycommands register etc.
    if not es.exists('saycommand', '/commandlist'):
	    es.regsaycmd('/commandlist', 'superhero/commandlist')
    if not es.exists('saycommand', '/shmenu'):
	    es.regsaycmd('/shmenu', 'superhero/commandlist')
    if not es.exists('saycommand', '/sh'):
	    es.regsaycmd('/sh', 'superhero/commandlist')
    if not es.exists('saycommand', '/help'):
        es.regsaycmd('/help', 'superhero/superherohelp')
    if not es.exists('saycommand', '/showmenu'):
        es.regsaycmd('/showmenu', 'superhero/showmenu')
    if not es.exists('saycommand', '/drop'):
        es.regsaycmd('/drop', 'superhero/drop')
    if not es.exists('saycommand', '/pick'):
        es.regsaycmd('/pick', 'superhero/pick')
    if not es.exists('saycommand','/savexp'):
        es.regsaycmd('/savexp', 'superhero/savexp')
    if not es.exists('saycommand', '/showxp'):
        es.regsaycmd('/showxp', 'superhero/showxp')
    if not es.exists('saycommand', '/myheroes'):
        es.regsaycmd('/myheroes', 'superhero/myheroes')
    if not es.exists('command','hasHero'):
        es.regcmd('hasHero', 'superhero/hasHero')
    if not es.exists('saycommand','/buyxp'):
        es.regsaycmd('/buyxp','superhero/buyxp')
    if not es.exists('saycommand', '/herolist'):
        es.regsaycmd('/herolist', 'superhero/herolist')
    if not es.exists('saycommand', '/clearpowers'):
        es.regsaycmd('/clearpowers', 'superhero/clearpowers')
    if not es.exists('saycommand', '/playerinfo'):
        es.regsaycmd('/playerinfo', 'superhero/playerinfo')
    if not es.exists('clientcommand','+power1'):
        es.regclientcmd('+power1', 'superhero/power')
    if not es.exists('clientcommand','-power1'):
        es.regclientcmd('-power1', 'superhero/poweroff')
    if not es.exists('clientcommand','+power2'):
        es.regclientcmd('+power2', 'superhero/power')
    if not es.exists('clientcommand','-power2'):
        es.regclientcmd('-power2', 'superhero/poweroff')
    if not es.exists('clientcommand','+power3'):
        es.regclientcmd('+power3', 'superhero/power')
    if not es.exists('clientcommand','-power3'):
        es.regclientcmd('-power3', 'superhero/poweroff') 
    es.doblock('corelib/noisy_on')      
    print "[SH] Loading done."
    
def unload():
    print "[SH] Unloading..."
    es.sql('close','userdata')
    es.unload('superhero/heroes')
    es.unload('superhero/admins')
    es.doblock('corelib/noisy_off')
    #es.unload('ezrestrict')
    print "[SH] Unloading done."
    helpbox.delete()
    commandlist.delete()
    es.unregsaycmd('/myheroes')
    es.unregsaycmd('/showmenu')
    es.unregsaycmd('/showxp')
    es.unregsaycmd('/drop')
    es.unregsaycmd('/savexp')
    es.unregsaycmd('/commandlist')
    es.unregsaycmd('/help')
    es.unregsaycmd('/pick')
    es.unregsaycmd('/buyxp')
    es.unregsaycmd('/clearpowers')
    es.unregsaycmd('/herolist')
    es.unregclientcmd('+power1')
    es.unregclientcmd('+power2')
    es.unregclientcmd('+power3')
   
def es_map_start(ev):
    es.ServerVar('sh_version', info['version'], 'Superhero Mod').makepublic()
    es.delayed(1,'es_xdoblock superhero/setVersion')
    es.server.cmd('es_xset sh_version %s' % info['version'])
    
def setVersion():
    es.ServerVar('sh_version', info['version'], 'Superhero Mod').makepublic()
    es.server.cmd('es_xset sh_version %s' % info['version'])
    es.delayed(5,'es_xdoblock superhero/setVersion')
    
def player_activate(ev):
    userid = str(ev['userid'])
    steamid = es.getplayersteamid(userid)
    if steamid == 'BOT': steamid = es.getplayername(userid)
    if isPlayer_exist(userid):
        # players exists
        print "Player",userid,"exists"
        # Get the player's data from the database
        getplayer(userid)
    else:
        # Player does not exist
        print "Player",userid,"does not exist, create database entry"
        addplayer(userid)
   	# Add the Connected number +1
    	es.sql('query','userdata',"UPDATE users SET connected = (connected + 1) WHERE id='%s'" % steamid)
        if steamid == 'BOT':
            return
    	Users[userid]['savexp'] = 1
    	Users[userid]['cmdlist'] = 1
        
def isPlayer_exist(userid):
    userid = str(userid)
    steamid = es.getplayersteamid(userid)
    if steamid == 'BOT': steamid = es.getplayername(userid)
    exists = es.sql('queryvalue','userdata',"SELECT id FROM users WHERE id = '%s'" % steamid)
    return exists
    
def getplayer(userid):
    userid = str(userid)
    steamid = es.getplayersteamid(userid)
    if steamid == 'BOT': steamid = es.getplayername(userid)
    # Certain data fetch and write the player
    write_player(userid)
    
def addplayer(userid):
    userid = str(userid)
    steamid = es.getplayersteamid(userid)
    if steamid == 'BOT': steamid = es.getplayername(userid)
    now = int(time.time())
    es.sql('query','userdata',"INSERT OR REPLACE INTO users ('id','created') VALUES ('%s','%i')" % (steamid,now))
    # Certain data of the player create
    write_player(userid)
    print "Player",userid,"successfully created!"
        
def write_player(userid):
    userid = str(userid)
    steamid = es.getplayersteamid(userid)
    if steamid == 'BOT': steamid = es.getplayername(userid)
    # Players write to the user group
    if not es.exists('key','Users',userid):
        Users[userid] = keyvalues.KeyValues(name=userid)
    # Create temporary user group
    if es.exists('keygroup', 'user_dict'):
        es.keygroupdelete('user_dict')
        es.keygroupcreate('user_dict')
    else:
        es.keygroupcreate('user_dict')
    # create the user_dict with the keygroup
    user_dict = keyvalues.getKeyGroup("user_dict")
    es.sql('query','userdata','user_dict',"SELECT * FROM users WHERE id = '%s'" % steamid)
    for keyname in user_dict['1']:
        # Write the data from the Keygroup in the user group
        Users[userid][str(keyname)] = user_dict['1'][str(keyname)]
        
def player_disconnect(ev):
    userid = ev['userid']
    saveplayer(userid)
        
def saveplayer(userid):
    userid = str(userid)
    steamid = es.getplayersteamid(userid)
    if steamid == 'BOT': steamid = es.getplayername(userid)
    lastplayed = int(time.time())
    es.sql('query','userdata',"UPDATE users SET level='%i',xp='%i',unspent = '%i',lastplayed='%i',heroes='%s',power1='%s',power2='%s',power3='%s' WHERE id='%s'" % (int(Users[userid]['level']),int(Users[userid]['xp']),int(Users[userid]['unspent']),lastplayed,str(Users[userid]['heroes']),str(Users[userid]['power1']),str(Users[userid]['power2']),str(Users[userid]['power3']),str(Users[userid]['id'])))
    
def player_spawn(ev):
    steamid = es.getplayersteamid
    if steamid == 'BOT':
        return
    userid  = str(ev['userid'])
    player = playerlib.getPlayer(userid)
    wcs_dead = player.isdead
    if wcs_dead != 1:
        steamid = es.getplayersteamid(userid)
        player = playerlib.getPlayer(userid)
        spawn_msg = langlib.Strings(es.getAddonPath('superhero') + '/languages/spawn_msg.ini')
    	global popup_language
    	if userid in Users:
            es.tell(userid,'#multi',spawn_msg('spawn_cmdlist',lang=str(popup_language)))
            es.sexec(userid,'say','/showxp')
    	    es.tell(userid,'#multi',spawn_msg('spawn_latest',lang=str(popup_language)))
    	if int(player.isdead) != 1:
            if int(es.ServerVar('start_level')) > 0:
                if userid in Users:
                    if int(Users[userid]['level']) == 0:
                        es.tell(userid,'#multi',spawn_msg('spawn_startlevel',lang=str(popup_language)))
                    	sh_levelup(userid,int(es.ServerVar('start_level')))
	
def bomb_planted(ev):
    userid = ev['userid']
    steamid = es.getplayersteamid
    if steamid == 'BOT':
        return
    xp = random.randint(5,35)
    xp_msg = langlib.Strings(es.getAddonPath('superhero') + '/languages/xp_msg.ini')
    global popup_language
    sh_givexp(userid, xp,xp_msg('xp_bombplanted',lang=str(popup_language)))
   
def bomb_exploded(ev):
    userid = ev['userid']
    steamid = es.getplayersteamid
    if steamid == 'BOT':
        return
    xp = random.randint(5,35)
    xp_msg = langlib.Strings(es.getAddonPath('superhero') + '/languages/xp_msg.ini')
    global popup_language
    sh_givexp(userid, xp,xp_msg('xp_bombexploded',lang=str(popup_language)))

def bomb_defused(ev):
    userid = ev['userid']
    steamid = es.getplayersteamid
    if steamid == 'BOT':
        return
    xp = random.randint(10,70)
    xp_msg = langlib.Strings(es.getAddonPath('superhero') + '/languages/xp_msg.ini')
    global popup_language
    sh_givexp(userid, xp,xp_msg('xp_bombdefused',lang=str(popup_language)))
    
def hostage_rescued(ev):
    userid = ev['userid']
    steamid = es.getplayersteamid
    if steamid == 'BOT':
        return
    xp = random.randint(1,10)
    xp_msg = langlib.Strings(es.getAddonPath('superhero') + '/languages/xp_msg.ini')
    global popup_language
    sh_givexp(userid, xp,xp_msg('xp_hostage',lang=str(popup_language)))
    
def player_death(event_var):
    userid = str(event_var['userid'])
    attacker = str(event_var['attacker'])
    weapon = str(event_var['weapon'])
    if weapon != 'world':
        if weapon != 'worldspawn':
            if userid != attacker:
                if event_var['es_userteam'] != event_var['es_attackerteam']: 
                    # Normal Player kill
                    xp_kill_min = es.ServerVar('xp_kill_min')
                    xp_kill_max = es.ServerVar('xp_kill_max')
                    xp = random.randint(xp_kill_min,xp_kill_max)
                    if attacker != '0':
                        if userid != '0':
                            level_dif = int(Users[userid]['level']) - int(Users[attacker]['level'])
                            if Users[attacker]['level'] < 1:
                                xp = xp * float(es.ServerVar('xp_multi'))
                            if level_dif > 1:
                                xp = xp * level_dif * level_dif
                            elif level_dif == 1:
                                xp = xp * 2
                            steamid = es.getplayersteamid
                            if steamid == 'BOT':
                                return
                            xp_msg = langlib.Strings(es.getAddonPath('superhero') + '/languages/xp_msg.ini')
                            global popup_language
                            sh_givexp(attacker,xp,xp_msg('xp_kill',lang=str(popup_language)))
                   
def showxp():
    steamid = es.getplayersteamid
    if steamid == 'BOT':
	return
    userid = str(es.getcmduserid())
    if es.exists('userid',userid):
        player = playerlib.getPlayer(userid)
        wcs_dead = player.isdead
        if wcs_dead != 1:
            level = int(Users[userid]['level'])+1
            xp_next_level = int(es.ServerVar('xp_next_level'))
            xp_multi = float(es.ServerVar('xp_multi'))
            xp = str(int(level*level*xp_next_level*xp_multi))
            string = '#lightgreen'+str(Users[userid]['xp'])+'/'+xp
            es.tell(userid,'#multi','#green[SH] Level#lightgreen',Users[userid]['level'],'-',string,'#greenXP')
                   
def sh_givexp(userid,amount,reason):
    steamid = es.getplayersteamid
    if steamid == 'BOT':
        return
    userid = str(userid)
    reason = str(reason)
    amount = int(amount)
    level = int(Users[userid]['level'])
    if level < int(es.ServerVar('max_level')):
        level += 1
        xp_next_level = int(es.ServerVar('xp_next_level'))
        xp_multi = float(es.ServerVar('xp_multi'))
        #xp_grenze = ((level + 1)*xp_next_level)*xp_multi
        xp_grenze = int((level*level)*xp_next_level*xp_multi)
        xp = amount + int(Users[userid]['xp'])
        if xp >= xp_grenze:
            # The player is above max xp
            Users[userid]['xp'] = (xp - xp_grenze)
            sh_levelup(userid,1)
        else:
            Users[userid]['xp'] = xp
        # Show the player's current level XP
        xp_msg = langlib.Strings(es.getAddonPath('superhero') + '/languages/xp_msg.ini')
        global popup_language
        tokens = {}
        tokens['amount'] = amount
        es.tell(userid,'#multi',xp_msg('xp_gain',tokens,lang=str(popup_language)),reason)
        es.sexec(userid,'say','/showxp')
        
def sh_levelup(userid,amount):
    steamid = es.getplayersteamid
    if steamid == 'BOT':
        return
    userid = str(userid)
    amount = int(amount)
    Users[userid]['level'] = int(Users[userid]['level']) + amount
    Users[userid]['unspent'] = int(Users[userid]['unspent']) + amount
    es.playsound(userid, 'ambient/tones/elev1.wav', 1.0)
    #es.playsound(userid, 'plats/elevbell1.wav', 1.0)
    xp_msg = langlib.Strings(es.getAddonPath('superhero') + '/languages/xp_msg.ini')
    global popup_language
    es.tell(userid,'#multi',xp_msg('xp_levelup',lang=str(popup_language)))
     
def map_end(ev):
    es.msg('#multi','#green[SH]#lightgreen Map end... Saving Players...')
    for userid in Users:
        saveplayer(userid)
        steamid = es.getplayersteamid
        if steamid == 'BOT':
            return
        Users[str(userid)]['savexp'] = 1
        es.server.cmd('es_sexec %s say /savexp' % userid)
        
def round_end(ev):
    global roundend
    roundend = 1
    es.msg('#multi','#green[SH]#lightgreen Saving Players...')
    for userid in Users:
        saveplayer(userid)    
    renew()
    
def commandlist():
    userid = es.getcmduserid()
    #close_popups(userid)
    popuplib.send('commandlist',userid)
    
def commandlist_selection(userid,choice,name):
    userid = str(userid)
    cmdlist_msg = langlib.Strings(es.getAddonPath('superhero') + '/languages/cmdlist_msg.ini')
    global popup_language
    if choice != None:
        if str(choice) == 'disable':
            Users[userid]['cmdlist'] = 0
            es.tell(userid,'#multi',cmdlist_msg('cmdlist_disable',lang=str(popup_language)))
        elif str(choice) == 'enable':
            Users[userid]['cmdlist'] = 1
            es.tell(userid,'#multi',cmdlist_msg('cmdlist_enable',lang=str(popup_language)))
        else:
            popupname = '/'+str(choice)
            es.sexec(userid,'say',popupname)
    
def superherohelp():
    userid = es.getcmduserid()
    #close_popups(userid)
    popuplib.send('helpbox',userid)

def showmenu():
    userid = es.getcmduserid()
    userid = str(userid)
    global menuname
    menuname = "showmenu"+"_"+userid
    menuname = popuplib.easymenu(menuname, 'choice', showmenu_selection)
    showmenu_popup = langlib.Strings(es.getAddonPath("superhero") + "/languages/showmenu_popup.ini")
    global popup_language
    menuname.settitle(showmenu_popup('showmenu_title',lang=str(popup_language)))
    tokens = {}
    tokens['unspent'] = str(Users[userid]['unspent'])
    menuname.setdescription(showmenu_popup('showmenu_desc',tokens,lang=str(popup_language)))
    herolist = str(es.ServerVar('herolist')).split(',')
    for hero in herolist:
        userheroes = str(Users[userid]['heroes']).split(',')
        if not hero in userheroes:
            text = langlib.Strings(es.getAddonPath("superhero/heroes/"+hero+ "/strings.ini"))
            if int(text("req_level")) <= int(Users[userid]['level']):
                string = str(text("heroname"))+'    -   '+str(text("description",lang=str(popup_language)))
                menuname.addoption(hero,string)
    menuname = "showmenu"+"_"+userid
    #close_popups(userid)
    popuplib.send(menuname,userid)
    
def showmenu_selection(userid,choice,popupname):
    userid = str(userid)
    showmenu_msg = langlib.Strings(es.getAddonPath("superhero/languages/showmenu_msg.ini"))
    global popup_language
    if int(Users[userid]['unspent']) != 0:
        text = langlib.Strings(es.getAddonPath("superhero/heroes/"+choice+ "/strings.ini"))
        req_level = int(text('req_level'))
        level = int(Users[userid]['level'])
        powerx = '0'
        powers = 0
        
        if int(text('power')) == 1:
            if str(Users[userid]['power3']) != '0':
                powers += 1
            else:
                powerx = 'power3'
            if str(Users[userid]['power2']) != '0':
                powers += 1
            else:
                powerx = 'power2'
            if str(Users[userid]['power1']) != '0':
                powers += 1
            else:
                powerx = 'power1'
            if powers == 3:
                es.tell(userid,'#multi',showmenu_msg('showmenu_allpowers',lang=str(popup_language)))
                return
        if req_level <= level:
            heroes = Users[userid]['heroes']
            heroes = heroes.split(',')
            heroes.append(choice)
            string = heroes[0]
            for hero in heroes:
                if not hero in string:
                    string = string+','+str(hero)
            Users[userid]['heroes'] = string
            Users[userid]['unspent'] = int(Users[userid]['unspent']) - 1
            Users[userid][powerx] = choice
            tokens = {}
            tokens['choice'] = choice
            es.tell(userid,'#multi',showmenu_msg('showmenu_picked',tokens,lang=str(popup_language)))
            if powerx != '0':
                tokens = {}
                tokens['powerx'] = '+'+powerx
                es.tell(userid,showmenu_msg('showmenu_bind',tokens,lang=str(popup_language)))
            if int(Users[userid]['unspent']) > 0:
                es.sexec(userid,'say','/showmenu')
    else:
        es.tell(userid,'#multi',showmenu_msg('showmenu_nopoints',lang=str(popup_language)))
        
def hasHero(userid,hero):
    userid = str(userid)
    steamid = es.getplayersteamid(userid)
    if steamid == 'BOT':
    	return
    if userid in Users:
        hero = str(hero)
        heroes = Users[userid]['heroes']
        heroes = heroes.split(',')
        if hero in heroes:
            return 'true'
            
def drop():
    userid = str(es.getcmduserid())
    heroname = str(es.getargs())
    global popup_language
    drop_msg = langlib.Strings(es.getAddonPath("superhero/languages/drop_msg.ini"))
    if int(es.ServerVar('drop_alive')) == 0:
        if int(playerlib.getPlayer(userid).isdead) == 0:
            es.tell(userid,'#multi',drop_msg('drop_alive',lang=str(popup_language)))
            return
    heroes = Users[userid]['heroes']
    heroes = heroes.split(',')
    text = langlib.Strings(es.getAddonPath("superhero/heroes/"+heroname+ "/strings.ini"))
    tokens = {}
    tokens['heroname'] = heroname
    if heroname in heroes:
        heroes.remove(heroname)
        string = heroes[0]
        for hero in heroes:
            if not hero in string:
                string = string+','+str(hero)
        Users[userid]['heroes'] = string
        Users[userid]['unspent'] = int(Users[userid]['unspent']) + 1
        if int(text('power')) == 1:
            if Users[userid]['power1'] == heroname:
               Users[userid]['power1'] = '0'
            if Users[userid]['power2'] == heroname:
                Users[userid]['power2'] = '0'
            if Users[userid]['power3'] == heroname:
                Users[userid]['power3'] = '0'
                
        es.tell(userid,'#multi',drop_msg('drop_suc',tokens,lang=str(popup_language)))
    else:
        es.tell(userid,'#multi',drop_msg('drop_not',tokens,lang=str(popup_language)))      
        
def pick():
    userid = str(es.getcmduserid())
    choice = str(es.getargs())
    userid = str(userid)
    pick_msg = langlib.Strings(es.getAddonPath("superhero/languages/pick_msg.ini"))
    global popup_language
    if int(Users[userid]['unspent']) != 0:
        if not choice in str(Users[userid]['heroes']):
            text = langlib.Strings(es.getAddonPath("superhero/heroes/"+choice+ "/strings.ini"))
            req_level = int(text('req_level'))
            level = int(Users[userid]['level'])
            powerx = '0'
            powers = 0
            if int(text('power')) == 1:
                if str(Users[userid]['power3']) != '0':
                    powers += 1
                else:
                    powerx = 'power3'
                if str(Users[userid]['power2']) != '0':
                    powers += 1
                else:
                    powerx = 'power2'
                if str(Users[userid]['power1']) != '0':
                    powers += 1
                else:
                    powerx = 'power1'
                if powers == 3:
                    es.tell(userid,'#multi',pick_msg('pick_allpowers',lang=str(popup_language)))
                    return
            tokens = {}
            if req_level <= level:
                heroes = Users[userid]['heroes']
                heroes = heroes.split(',')
                heroes.append(choice)
                string = heroes[0]
                for hero in heroes:
                    if not hero in string:
                        string = string+','+str(hero)
                Users[userid]['heroes'] = string
                Users[userid]['unspent'] = int(Users[userid]['unspent']) - 1
                Users[userid][powerx] = choice
                tokens['choice'] = choice
                es.tell(userid,'#multi',pick_msg('pick_picked',tokens,lang=str(popup_language)))
                if powerx != '0':
                    tokens['powerx'] = '+'+powerx
                    es.tell(userid,'#multi',pick_msg('pick_bind',tokens,lang=str(popup_language)))
            else:
                tokens['reqlevel'] = req_level
                es.tell(userid,'#multi',pick_msg('pick_reqlevel',tokens,lang=str(popup_language)))
        else:
            es.tell(userid,'#multi',pick_msg('pick_nohero',lang=str(popup_language)))
    else:
        es.tell(userid,'#multi',pick_msg('pick_nopoints',lang=str(popup_language)))
        
def myheroes():
    userid = str(es.getcmduserid())
    heroes = Users[userid]['heroes']
    heroes = heroes.split(',')
    menuname = "myheroes"+"_"+userid
    menuname = popuplib.easymenu(menuname,None, myheroes_selection)
    myheroes_popup = langlib.Strings(es.getAddonPath("superhero") + "/languages/myheroes_popup.ini")
    global popup_language
    menuname.settitle(myheroes_popup('myheroes_title',lang=str(popup_language)))
    menuname.setdescription(myheroes_popup('myheroes_desc',lang=str(popup_language)))
    for hero in heroes:
        if hero != '0':
            if str(Users[userid]['power1']) == hero:
                menuname.addoption(str(hero),str(hero)+' [+power1]')
            elif str(Users[userid]['power2']) == hero:
                menuname.addoption(str(hero),str(hero)+' [+power2]')
            elif str(Users[userid]['power3']) == hero:
                menuname.addoption(str(hero),str(hero)+' [+power3]')
            else:
                menuname.addoption(str(hero),hero)
    menuname = "myheroes"+"_"+userid
    #close_popups(userid)
    popuplib.send(menuname,userid)
    
def myheroes_selection(userid,heroname,popupname):
    userid = str(userid)
    es.server.cmd('es_sexec %s say /drop %s' % (userid,heroname))
    
def herolist():
    userid = str(es.getcmduserid())
    heroes = str(es.ServerVar('herolist'))
    heroes = heroes.split(',')
    herolist = popuplib.easymenu('herolist',None,None)
    herolist_popup = langlib.Strings(es.getAddonPath("superhero") + "/languages/herolist_popup.ini")
    global popup_language
    herolist.settitle(herolist_popup("herolist_title",lang=str(popup_language)))
    for hero in heroes:
        text = langlib.Strings(es.getAddonPath("superhero/heroes/"+hero+ "/strings.ini"))
        string = str(text("heroname"))+'    -   '+str(text("description",lang=str(popup_language)))
        herolist.addoption(None,string)
    #close_popups(userid)
    popuplib.send('herolist',userid)
    
def clearpowers():
    userid = str(es.getcmduserid())
    global popup_language
    drop_msg = langlib.Strings(es.getAddonPath("superhero/languages/drop_msg.ini"))
    if int(es.ServerVar('drop_alive')) == 0:
    	if int(playerlib.getPlayer(userid).isdead) == 0:
    		es.tell(userid,'#multi',drop_msg('drop_alive',lang=str(popup_language)))
        	return
    heroes = Users[userid]['heroes']
    heroes = heroes.split(',')
    counter = 0
    for hero in heroes:
        if hero != '0':
            Users[userid]['unspent'] = int(Users[userid]['unspent']) + 1
            if Users[userid]['power1'] == hero:
                Users[userid]['power1'] = '0'
            if Users[userid]['power2'] == hero:
                Users[userid]['power2'] = '0'
            if Users[userid]['power3'] == hero:
                Users[userid]['power3'] = '0'
            counter += 1
    Users[userid]['heroes'] = '0'
    other_msg = langlib.Strings(es.getAddonPath("superhero") + "/languages/other_msg.ini")
    tokens = {}
    tokens['counter'] = counter
    es.tell(userid,'#multi',other_msg('other_cleared',tokens,lang=str(popup_language)))
 
def power():
    powerx = str(es.getargv(0))
    powerx = powerx.split('+')
    powerx = str(powerx[1])
    userid = str(es.getcmduserid())
    if userid in Users:
        Users[userid]['powerx'] = powerx
        if str(Users[userid][powerx]) != '0':
            es.server.queuecmd('es_xdoblock superhero/heroes/'+str(Users[userid][powerx])+'/power')

def poweroff():
    powerx = str(es.getargv(0))
    powerx = powerx.split('-')
    powerx = str(powerx[1])
    userid = str(es.getcmduserid())
    if userid in Users:
        Users[userid]['powerx'] = powerx
        if str(Users[userid][powerx]) != '0':
            es.server.queuecmd('es_xdoblock superhero/heroes/'+str(Users[userid][powerx])+'/poweroff')
                                     
def round_start(ev):
    global roundend
    roundend = 0
    playerinfo_list_build()
    steamid = es.getplayersteamid
    if steamid == 'BOT':
        return
    for userid in Users:
        Users[userid]['savexp'] = 1    
    
def playerinfo_list_build():
    # Create and update player info
    playerinfo_list = popuplib.easymenu('playerinfo_list',None,playerinfo_list_selection)
    playerinfo_popup = langlib.Strings(es.getAddonPath("superhero") + "/languages/playerinfo_popup.ini")
    global popup_language
    playerinfo_list.settitle(playerinfo_popup('playerinfo_title',lang=str(popup_language)))
    PlayerList = playerlib.getPlayerList('#all,#all')
    counter = 0 
    for player in PlayerList:
        if str(player.userid) in Users:
            playerinfo_list.addoption(player,(str(player.name)+' [LvL '+str(Users[str(player.userid)]['level'])+']'))
            counter += 1     
    if counter == 0:
        playerinfo_list.addoption(None,playerinfo_popup('playerinfo_update',lang=str(popup_language)))
          
def playerinfo():
    userid = es.getcmduserid()
    #close_popups(userid)
    popuplib.send('playerinfo_list',userid)
    
def playerinfo_list_selection(userid,choice,popup):
    if str(choice.userid) in Users:
        id = choice.userid
        playerinfo = popuplib.create('playerinfo')
        playerinfo.addline('-> 1.'+str(es.getplayername(id)))
        playerinfo.addline('---------')
        heroes = Users[str(id)]['heroes']
        heroes = heroes.split(',')
        counter = 0
        for hero in heroes:
            hero = str(hero)
            if hero != '0':
                counter += 1
                playerinfo.addline(str(counter)+' - '+hero)
        if counter == 0:
            playerinfo_popup = langlib.Strings(es.getAddonPath("superhero") + "/languages/playerinfo_popup.ini")
            global popup_language
            playerinfo.addline(playerinfo_popup('playerinfo_noheroes',lang=str(popup_language)))
        playerinfo.addline('---------')
        playerinfo.addline('-> 2.Back')
        playerinfo.menuselect = playerinfo_selection
        #close_popups(userid)
        popuplib.send('playerinfo',userid)

def playerinfo_selection(userid, choice, popupid):
    if str(choice) != '10':
        #close_popups(userid)
        popuplib.send('playerinfo_list',userid)
   
def buyxp():
    userid = str(es.getcmduserid())
    buyxp_msg = langlib.Strings(es.getAddonPath("superhero") + "/languages/buyxp_msg.ini")
    global popup_language
    tokens = {}
    if int(es.ServerVar('buyxp')) != 0:
        playerList = playerlib.getPlayerList('#human,#all')
        if len(playerList) >= int(es.ServerVar('buyxp_players')):
            amount = es.getargs()
            if amount != None:
                player = playerlib.getPlayer(userid)
                cash = int(player.getCash())
                if str(amount) == 'all':
                    xp = cash * float(es.ServerVar('xp_dollar'))
                    string = 'Used '+str(amount)+'$'
                    sh_givexp(userid,int(xp),string)
                    player.setCash(0)
                    return
                    
                elif str(amount) == '#all':
                    xp = cash * float(es.ServerVar('xp_dollar'))
                    string = 'Used '+str(amount)+'$'
                    sh_givexp(userid,int(xp),string)
                    player.setCash(0)
                    return         
                amount = int(amount)
                if amount >= 100:
                    if amount <= cash:
                        xp = amount * float(es.ServerVar('xp_dollar'))
                        string = 'Used '+str(amount)+'$'
                        sh_givexp(userid,int(xp),string)
                        player.setCash(cash-amount)
                    else:
                        tokens['amount'] = amount
                        es.tell(userid,'#multi',buyxp_msg('buyxp_notamount',tokens,lang=str(popup_language)))
                else:
                    es.tell(userid,'#multi',buyxp_msg('buyxp_notenough',lang=str(popup_language)))
            else:
                es.tell(userid,'#multi',buyxp_msg('buyxp_none',lang=str(popup_language)))
        else:
            tokens['players'] = es.ServerVar('buyxp_players')
            es.tell(userid,'#multi',buyxp_msg('buyxp_players',tokens,lang=str(popup_language)))
    else:
        es.tell(userid,'#multi',buyxp_msg('buyxp_disabled',lang=str(popup_language)))

def savexp():
    steamid = es.getplayersteamid
    if steamid == 'BOT':
        return
    userid = str(es.getcmduserid())
    if userid in Users:
        if 'savexp' in Users[userid]:
            other_msg = langlib.Strings(es.getAddonPath("superhero") + "/languages/other_msg.ini")
            global popup_language
            if int(Users[userid]['savexp']) == 1:
                # Save the player first to the Database
                lastplayed = int(time.time())
                #es.sql('query','userdata',"INSERT OR REPLACE INTO users (id,created,level,xp,unspent,lastplayed,heroes,power1,power2,power3,connected) VALUES ('%s','%i','%i','%i','%i','%i','%s','%s','%s','%s','%i')" % (str(Users[userid]['id']),int(Users[userid]['created']),int(Users[userid]['level']),int(Users[userid]['xp']),int(Users[userid]['unspent']),lastplayed,str(Users[userid]['heroes']),str(Users[userid]['power1']),str(Users[userid]['power2']),str(Users[userid]['power3']),int(Users[userid]['connected'])))
                es.sql('query','userdata',"UPDATE users SET level='%i',xp='%i',unspent = '%i',lastplayed='%i',heroes='%s',power1='%s',power2='%s',power3='%s' WHERE id='%s'" % (int(Users[userid]['level']),int(Users[userid]['xp']),int(Users[userid]['unspent']),lastplayed,str(Users[userid]['heroes']),str(Users[userid]['power1']),str(Users[userid]['power2']),str(Users[userid]['power3']),str(Users[userid]['id'])))
                if es.exists('keygroup', 'tmp_dict'):
                    es.keygroupdelete('tmp_dict')
                    es.keygroupcreate('tmp_dict')
                else:
                    es.keygroupcreate('tmp_dict')
                # das dictionary tmp_dict mit der keygruppe erstellen
                tmp_dict = keyvalues.getKeyGroup("tmp_dict")
                steamid = str(es.getplayersteamid(userid))
                es.sql('query','userdata','tmp_dict',"SELECT * FROM users WHERE id = '%s'" % steamid)
                counter = 0
                leng = 0
                for a in tmp_dict['1']:
                    leng += 1
                for key in tmp_dict['1']:
                    if str(tmp_dict['1'][str(key)]) == str(Users[userid][str(key)]):
                        counter += 1
                leng -= 1
                if counter == leng:
                    es.tell(userid,'#multi',other_msg('other_savesuc',lang=str(popup_language)))
                    Users[userid]['savexp'] = 0
                else:
                    es.tell(userid,'#multi',other_msg('other_saveprob',lang=str(popup_language)))
            else:
                es.tell(userid,'#multi',other_msg('other_savealr',lang=str(popup_language)))
        else:
            Users[userid]['savexp'] = 1
            
def renew():
    es.msg('#multi','#green[SH] #lightgreenCleansing all Users...')
    steamid = es.getplayersteamid
    if steamid == 'BOT':
        # Deleting all Users
        global Users
        Users = keyvalues.getKeyGroup("Users")
        Users = {}
        # Adding the Users again to the Dict
        PlayerList = playerlib.getPlayerList('#all,#all')
        for player in PlayerList:
            getplayer(player.userid)